package com.example.liu.mygame.view;

import java.util.ArrayList;

import com.example.liu.mygame.R;
import com.example.liu.mygame.entity.*;
import com.example.liu.mygame.global.Config;
import com.example.liu.mygame.model.BaseModel;
import com.example.liu.mygame.model.Plant;
import com.example.liu.mygame.model.TouchAble;

import android.R.bool;
import android.R.integer;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Point;
import android.graphics.Typeface;
import android.util.Log;
import android.view.MotionEvent;
import android.view.SurfaceHolder;
import android.view.SurfaceView;

//Ϸ·
//ֿƶϷ԰оһ ÷ͼ ÿλƵʱҪY
//ȻĿ϶ǰ YСǰ漴ĻϱԵľ
//Ϸ϶ͨϷп
public class GameView extends SurfaceView implements SurfaceHolder.Callback,
		Runnable {

	private Canvas canvas;
	private Paint paint;
	private SurfaceHolder surfaceHolder;
	private boolean gameRunFlag;
	private Context context;// ڴͼƬַ

	// GameViewܹеʵ嶼﷢󲢴
	private static GameView gameView;

	private ArrayList<BaseModel> deadList;// ʵ,϶ֺʵ᲻ʾǻҪ
	private ArrayList<BaseModel> gameLayout3;// ŵͼеʵ壻
	private ArrayList<BaseModel> gameLayout2;// ŵڶͼеʵ
	private ArrayList<BaseModel> gameLayout1;// ŵһͼеʵ

	// ܵ
	// Щһװһforѭд
	private ArrayList<BaseModel> gameLayout4plant0;
	private ArrayList<BaseModel> gameLayout4plant1;
	private ArrayList<BaseModel> gameLayout4plant2;
	private ArrayList<BaseModel> gameLayout4plant3;
	private ArrayList<BaseModel> gameLayout4plant4;

	// 彩ʬܵ
	private ArrayList<BaseModel> gamelayout4zombie0;
	private ArrayList<BaseModel> gamelayout4zombie1;
	private ArrayList<BaseModel> gamelayout4zombie2;
	private ArrayList<BaseModel> gamelayout4zombie3;
	private ArrayList<BaseModel> gamelayout4zombie4;

	// 彩ʬͨ˿ʹʬʵƶ
	private ZombieManager zombieManager;

	public GameView(Context context) {
		super(context);
		// TODO GameView
		this.context = context;
		paint = new Paint();
		surfaceHolder = getHolder();
		surfaceHolder.addCallback(this);
		gameRunFlag = true;

		gameView = this;

		if (Config.game == false) {
			canvas.drawBitmap(Config.gameOver, 0, 0, paint);
		}
	}

	@Override
	public void surfaceCreated(SurfaceHolder holder) {
		// TODO surfaceCreated
		// bitmapͼƬ
		createElement();
		new Thread(this).start();

	}

	private void createElement() {
		// TODO createElement
		// ֲ뽩ʬĸ߶Ȳֵ
		Config.heightYDistance = Config.zombieFrames[0].getHeight()
				- Config.flowerFrames[0].getHeight();
		// seedBankX긳ֵ
		Config.seedBankLocationX = (Config.deviceWidth - Config.seedBank
				.getWidth()) / 2;
		// ʼͼ
		gameLayout3 = new ArrayList<BaseModel>();

		// ˷ʱᴴƬ
		gameLayout2 = new ArrayList<BaseModel>();
		SeedFlower seedFlower = new SeedFlower(
				(Config.deviceWidth - Config.seedBank.getWidth()) / 2
						+ Config.seedFlower.getWidth() / 3
						+ Config.seedBank.getWidth() / 7,
				Config.seedBank.getHeight() / 10);
		SeedPea seedPea = new SeedPea(
				(Config.deviceWidth - Config.seedBank.getWidth()) / 2
						+ Config.seedFlower.getWidth() / 7
						+ Config.seedBank.getWidth() / 7 * 2,
				Config.seedBank.getHeight() / 10);

		gameLayout2.add(seedFlower);
		gameLayout2.add(seedPea);

		// Ӱ״̬еֲ
		gameLayout1 = new ArrayList<BaseModel>();
		deadList = new ArrayList<BaseModel>();

		gameLayout4plant0 = new ArrayList<BaseModel>();
		gameLayout4plant1 = new ArrayList<BaseModel>();
		gameLayout4plant2 = new ArrayList<BaseModel>();
		gameLayout4plant3 = new ArrayList<BaseModel>();
		gameLayout4plant4 = new ArrayList<BaseModel>();

		// ʬܵʼ
		gamelayout4zombie0 = new ArrayList<BaseModel>();
		gamelayout4zombie1 = new ArrayList<BaseModel>();
		gamelayout4zombie2 = new ArrayList<BaseModel>();
		gamelayout4zombie3 = new ArrayList<BaseModel>();
		gamelayout4zombie4 = new ArrayList<BaseModel>();

		// ʼʬ
		zombieManager = new ZombieManager();

		// ֲĺλ
		for (int i = 0; i < 5; i++) {
			for (int j = 0; j < 9; j++) {
				Config.plantPoints.put(i * 10 + j, new Point(
						(j + 2) * Config.deviceWidth / 11 - Config.deviceWidth
								/ 11 / 2, (i + 1) * Config.deviceHeight / 6));
				if (j == 0) {
					Config.raceWayYpoints[i] = (i + 1) * Config.deviceHeight
							/ 6;
				}
			}
		}
	}

	@Override
	public void surfaceChanged(SurfaceHolder holder, int format, int width,
			int height) {
		// TODO surfaceChanged

	}

	@Override
	public void surfaceDestroyed(SurfaceHolder holder) {
		// TODO surfaceDestroyed

	}

	// еĶ֡run
	// ƶ֡ʱҪעȽݸ Ȼڸͼ
	@Override
	public void run() {
		// TODO run
		while (gameRunFlag) {
			synchronized (surfaceHolder) {
				try {
					// ΪγɶЧҪĻ
					// ܶ߳ͬʱ
					canvas = surfaceHolder.lockCanvas();
					// 뱳ײͼ
					canvas.drawBitmap(Config.gameBK, 0, 0, paint);
					// Ϸֲڶͼ㣬ڱ֮
					canvas.drawBitmap(Config.seedBank,
							Config.seedBankLocationX, 0, paint);
					// ݸĲ
					updateData();
					// ֲ￨Ƭڶ㣩
					ondraw(canvas);
				} catch (Exception e) {
					// TODO: handle exception
				} finally {
					// ύ
					surfaceHolder.unlockCanvasAndPost(canvas);
					// CanvasAndPostҪн ܳʲôûֱʾ
					// ԷһĻ try catch
				}
			}
			// ÿѭ50һֱѭϵͳԴ˷
			// ʹ50ԭ42֡۾ͻΪģ142ͼƬÿѭ50뼴20֡
			// sleepsynchronizedеĻֳÿα˯Ȼٴαûи¼лɿ
			try {
				Thread.sleep(40);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

		}
	}

	private void updateData() {
		// ڴ˷нݸ
		// deadList
		deadList.clear();
		// һͼ
		for (BaseModel model : gameLayout1) {
			if (!model.isAlife()) {
				deadList.add(model);
			}
		}
		// ڶͼ
		for (BaseModel model : gameLayout2) {
			if (!model.isAlife()) {
				deadList.add(model);
			}
		}
		// ͼ
		for (BaseModel model : gameLayout3) {
			if (!model.isAlife()) {
				deadList.add(model);
			}
		}

		// ܵϵĽʬ
		for (BaseModel model : gamelayout4zombie0) {
			if (!model.isAlife()) {
				deadList.add(model);
			}
		}
		for (BaseModel model : gamelayout4zombie1) {
			if (!model.isAlife()) {
				deadList.add(model);
			}
		}
		for (BaseModel model : gamelayout4zombie2) {
			if (!model.isAlife()) {
				deadList.add(model);
			}
		}
		for (BaseModel model : gamelayout4zombie3) {
			if (!model.isAlife()) {
				deadList.add(model);
			}
		}
		for (BaseModel model : gamelayout4zombie4) {
			if (!model.isAlife()) {
				deadList.add(model);
			}
		}
		// ܵϵֲ
		for (BaseModel model : gameLayout4plant0) {
			if (!model.isAlife()) {
				deadList.add(model);
			}
		}
		for (BaseModel model : gameLayout4plant1) {
			if (!model.isAlife()) {
				deadList.add(model);
			}
		}
		for (BaseModel model : gameLayout4plant2) {
			if (!model.isAlife()) {
				deadList.add(model);
			}
		}
		for (BaseModel model : gameLayout4plant3) {
			if (!model.isAlife()) {
				deadList.add(model);
			}
		}
		for (BaseModel model : gameLayout4plant4) {
			if (!model.isAlife()) {
				deadList.add(model);
			}
		}
		// deadList
		for (BaseModel model : deadList) {
			// ڸͼбаƳ
			gameLayout1.remove(model);
			gameLayout2.remove(model);
			gameLayout3.remove(model);
			gamelayout4zombie0.remove(model);
			gamelayout4zombie1.remove(model);
			gamelayout4zombie2.remove(model);
			gamelayout4zombie3.remove(model);
			gamelayout4zombie4.remove(model);
		}
	}

	private void ondraw(Canvas canvas) {
		// TODO ondraw
		// ڴ˷нлͼҵ
		// ϷĲνлƣȻϷ·ľ
		// Ѿдõķֲ˳

		// Ƴֵ
		Paint paint2 = new Paint();
		paint2.setTypeface(Typeface.DEFAULT_BOLD);
		paint2.setTextSize(15);
		canvas.drawText(Config.sunlight + "", Config.deviceWidth * 2 / 7,
				Config.deviceHeight / 8, paint2);

		// ʬеdrawSelfʵֽʬƶ
		zombieManager.drawSelf(canvas, paint);

		// ܵӦôڵĲʷϷȻƳ
		// ܵdrawSelfлֲ
		// ˴ҲԽзĳ ˵ӦðЩظĴΪһòֵͬȥ
		for (BaseModel model : gameLayout4plant0) {
			model.drawSelf(canvas, paint);
		}
		for (BaseModel model : gameLayout4plant1) {
			model.drawSelf(canvas, paint);
		}
		for (BaseModel model : gameLayout4plant2) {
			model.drawSelf(canvas, paint);
		}
		for (BaseModel model : gameLayout4plant3) {
			model.drawSelf(canvas, paint);
		}
		for (BaseModel model : gameLayout4plant4) {
			model.drawSelf(canvas, paint);
		}

		// 㣨⣩
		for (BaseModel model : gameLayout3) {
			model.drawSelf(canvas, paint);
		}

		// ڶ
		for (BaseModel model : gameLayout2) {
			model.drawSelf(canvas, paint);
		}

		// ܵdrawSelfлƽʬ
		// ˴ҲԽзĳ ˵ӦðЩظĴΪһòֵͬȥ
		// ڶֲ￨ƬʬھһеʱӦÿԵסֲ￨Ƭ
		for (BaseModel model : gamelayout4zombie0) {
			model.drawSelf(canvas, paint);
		}
		for (BaseModel model : gamelayout4zombie1) {
			model.drawSelf(canvas, paint);
		}
		for (BaseModel model : gamelayout4zombie2) {
			model.drawSelf(canvas, paint);
		}
		for (BaseModel model : gamelayout4zombie3) {
			model.drawSelf(canvas, paint);
		}
		for (BaseModel model : gamelayout4zombie4) {
			model.drawSelf(canvas, paint);
		}

		// һ
		// gameLayout1gameLayout2ĲҪ߹ʷں
		for (BaseModel model : gameLayout1) {
			model.drawSelf(canvas, paint);
		}

		/*
		 * private m=200; Paint paint3 = new Paint(); paint3.setAlpha(100);
		 * canvas.drawRect(100, 100, 200, m, paint3); m-=5; ð͸Ч
		 * mǿ͸Чȥ mı仯СͿΪֲȴʱ
		 */
	}

	// дӦ¼
	@Override
	public boolean onTouchEvent(MotionEvent event) {
		// TODO onTouchEvent
		// Ӧ˵gameLayout1ȼ߹ʷgameLayout2Ϸ
		for (BaseModel model : gameLayout1) {
			// жǷΪtouchAbleֻ࣬touchAbleӦ
			if (model instanceof TouchAble) {
				// ȻonTouch¼鿴Ƿ񱻵ôtrue
				if (((TouchAble) model).onTouch(event)) {
					return true;
				}
			}
		}
		// ڶеȫʵ
		for (BaseModel model : gameLayout2) {
			// жǷΪtouchAbleֻ࣬touchAbleӦ
			if (model instanceof TouchAble) {
				// ȻonTouch¼鿴Ƿ񱻵ôtrue
				if (((TouchAble) model).onTouch(event)) {
					return true;
				}
			}
		}
		// еȫʵ
		for (BaseModel model : gameLayout3) {
			// жǷΪtouchAbleֻ࣬touchAbleӦ
			if (model instanceof TouchAble) {
				// ȻonTouch¼鿴Ƿ񱻵ôtrue
				if (((TouchAble) model).onTouch(event)) {
					return true;
				}
			}
		}
		return false;
	}

	// ȡGameViewķGameViewʵ
	public static GameView getInstance() {
		return gameView;
	}

	// EmplacePlantֲȼߣ
	public void applay4EmplacePlant(int locationX, int locationY,
			BaseModel model) {
		// TODO applay4EmplacePlant
		// ൱ڽݸ£onDrawлȡһԪؽлƣƹﻹиôͻҪһͬ
		// жڼϵĲҪͬsurfaceHolderõsurfaceHolderʱܹв
		synchronized (surfaceHolder) {
			// gameLayout1ŵڰ״ֲ̬ûз
			// newһڰ״̬ʵ
			// gameLayout1ֻ0~1ʵ
			if (gameLayout1.size() < 1) {
				if (model instanceof SeedPea) {
					gameLayout1.add(new EmplacePea(locationX, locationY));
				} else {
					gameLayout1.add(new EmplaceFlower(locationX, locationY));
				}
			}
		}

	}

	public void applay4Plant(int locationX, int locationY, BaseModel baseModel) {
		// TODO applay4Plant
		// žֲ̬
		// Կռ任ʱ䣬ΪֲӵʬڵĲԶЩ˵ǷΪ
		// ÿϣһǽʬļϣһֲӵļϣΪײ
		// Ϊ˼ײ¼ȥֲҪ㣬ʶֳɺܶ
		// ѭɰֲHashMapĿóÿԪlocationXlocationYбȽ
		// keyÿPaintıʾͬ
		synchronized (surfaceHolder) {// 
			Point point;
			for (Integer key : Config.plantPoints.keySet()) {
				// ҾlocationXlocationYҴĿ
				point = Config.plantPoints.get(key);
				if ((Math.abs(locationX - point.x) < Config.deviceWidth / 11 / 2)
						&& (Math.abs(locationY - point.y) < Config.deviceHeight / 6 / 2)) {
					// ܵʾ
					int raceWayIndex = 6;
					for (int i = 0; i < Config.raceWayYpoints.length; i++) {
						// ܵYֵ
						if (point.y == Config.raceWayYpoints[i]) {
							// Yֵôܵȷ
							raceWayIndex = i;
						}
					}
					if (isPlantExist(key, raceWayIndex)) {
						// ܵ¼
						switch (raceWayIndex) {
						case 0:
							if (baseModel instanceof EmplacePea) {
								gameLayout4plant0.add(new Pea(point.x, point.y,
										key));
								Config.sunlight -= 100;
							} else {
								gameLayout4plant0.add(new Flower(point.x,
										point.y, key));
								Config.sunlight -= 50;
							}
							break;
						case 1:
							if (baseModel instanceof EmplacePea) {
								gameLayout4plant1.add(new Pea(point.x, point.y,
										key));
								Config.sunlight -= 100;
							} else {
								gameLayout4plant1.add(new Flower(point.x,
										point.y, key));
								Config.sunlight -= 50;
							}
							break;
						case 2:
							if (baseModel instanceof EmplacePea) {
								gameLayout4plant2.add(new Pea(point.x, point.y,
										key));
								Config.sunlight -= 100;
							} else {
								gameLayout4plant2.add(new Flower(point.x,
										point.y, key));
								Config.sunlight -= 50;
							}
							break;
						case 3:
							if (baseModel instanceof EmplacePea) {
								gameLayout4plant3.add(new Pea(point.x, point.y,
										key));
								Config.sunlight -= 100;
							} else {
								gameLayout4plant3.add(new Flower(point.x,
										point.y, key));
								Config.sunlight -= 50;
							}
							break;
						case 4:
							if (baseModel instanceof EmplacePea) {
								gameLayout4plant4.add(new Pea(point.x, point.y,
										key));
								Config.sunlight -= 100;
							} else {
								gameLayout4plant4.add(new Flower(point.x,
										point.y, key));
								Config.sunlight -= 50;
							}
							break;
						default:
							break;
						}
					}
				}
			}
		}
	}

	// жϴ˴ǷѾֲķ
	// keyǱʾraceWayIndexȷӦһܵ
	private boolean isPlantExist(int key, int raceWayIndex) {
		switch (raceWayIndex) {
		case 0:
			for (BaseModel model : gameLayout4plant0) {
				//  Ǽ̳Plantӿڵ(Ϊӵⲻ̳Plant)
				if (model instanceof Plant) {
					// Ȼ˴key봫key
					if (key == ((Plant) model).getmapIndex()) {
						// ôش˴ֲֲ
						return false;
					}
				}
			}
			break;
		case 1:
			for (BaseModel model : gameLayout4plant1) {
				//  Ǽ̳Plantӿڵ(Ϊӵⲻ̳Plant)
				if (model instanceof Plant) {
					// Ȼ˴key봫key
					if (key == ((Plant) model).getmapIndex()) {
						// ôش˴ֲֲ
						return false;
					}
				}
			}
			break;
		case 2:
			for (BaseModel model : gameLayout4plant2) {
				//  Ǽ̳Plantӿڵ(Ϊӵⲻ̳Plant)
				if (model instanceof Plant) {
					// Ȼ˴key봫key
					if (key == ((Plant) model).getmapIndex()) {
						// ôش˴ֲֲ
						return false;
					}
				}
			}
			break;
		case 3:
			for (BaseModel model : gameLayout4plant3) {
				//  Ǽ̳Plantӿڵ(Ϊӵⲻ̳Plant)
				if (model instanceof Plant) {
					// Ȼ˴key봫key
					if (key == ((Plant) model).getmapIndex()) {
						// ôش˴ֲֲ
						return false;
					}
				}
			}
			break;
		case 4:
			for (BaseModel model : gameLayout4plant4) {
				//  Ǽ̳Plantӿڵ(Ϊӵⲻ̳Plant)
				if (model instanceof Plant) {
					// Ȼ˴key봫key
					if (key == ((Plant) model).getmapIndex()) {
						// ôش˴ֲֲ
						return false;
					}
				}
			}
			break;
		default:
			break;
		}
		return true;
	}

	// Flowerڲ
	public void giveBrith2Sun(int locationX, int locationY) {
		// TODO giveBrith2Sun
		// ס
		synchronized (surfaceHolder) {
			gameLayout3.add(new Sun(locationX, locationY));
		}
	}

	// Peaڲӵ
	public void giveBirth2Bullet(int locationX, int locationY) {
		// TODO Auto-generated method stub
		// ס
		synchronized (surfaceHolder) {// 
			Point point;
			for (Integer key : Config.plantPoints.keySet()) {
				// ҾlocationXlocationYҴĿ
				point = Config.plantPoints.get(key);
				if ((Math.abs(locationX - point.x) < Config.deviceWidth / 11 / 2)
						&& (Math.abs(locationY - point.y) < Config.deviceHeight / 6 / 2)) {
					// ܵʾ
					int raceWayIndex = 6;
					for (int i = 0; i < Config.raceWayYpoints.length; i++) {
						// ܵYֵ
						if (point.y == Config.raceWayYpoints[i]) {
							// Yֵôܵȷ
							raceWayIndex = i;
						}
					}

					switch (raceWayIndex) {
					case 0:
						gameLayout4plant0.add(new Bullet(locationX, locationY));
						break;
					case 1:
						gameLayout4plant1.add(new Bullet(locationX, locationY));
						break;
					case 2:
						gameLayout4plant2.add(new Bullet(locationX, locationY));
						break;
					case 3:
						gameLayout4plant3.add(new Bullet(locationX, locationY));
						break;
					case 4:
						gameLayout4plant4.add(new Bullet(locationX, locationY));
						break;
					default:
						break;
					}
				}
			}
		}
	}

	// ʬӦ뽩ʬ
	public void apply4AddZombie() {
		// TODO apply4AddZombie
		// Ƚ
		synchronized (surfaceHolder) {
			int raceWay = 0;
			// 0~4ܵʼ
			// Math.random()0~1Ĳ1double
			raceWay = (int) (Math.random() * 5);
			// Config.deviceWidth + 20ΪýʬĻ
			// Config.raceWayYpoints[raceWay] - Config.heightYDistance
			// Ϊýʬֲĵ׶
			switch (raceWay) {
			case 0:
				gamelayout4zombie0
						.add(new Zombie(Config.deviceWidth + 20,
								Config.raceWayYpoints[raceWay]
										- Config.heightYDistance, raceWay));
				break;
			case 1:
				gamelayout4zombie1
						.add(new Zombie(Config.deviceWidth + 20,
								Config.raceWayYpoints[raceWay]
										- Config.heightYDistance, raceWay));
				break;
			case 2:
				gamelayout4zombie2
						.add(new Zombie(Config.deviceWidth + 20,
								Config.raceWayYpoints[raceWay]
										- Config.heightYDistance, raceWay));
				break;
			case 3:
				gamelayout4zombie3
						.add(new Zombie(Config.deviceWidth + 20,
								Config.raceWayYpoints[raceWay]
										- Config.heightYDistance, raceWay));
				break;
			case 4:
				gamelayout4zombie4
						.add(new Zombie(Config.deviceWidth + 20,
								Config.raceWayYpoints[raceWay]
										- Config.heightYDistance, raceWay));
				break;
			default:
				break;
			}
		}
	}

	// ײ⣬ײķǽʬ
	public void checkCollision(Zombie zombie, int raceWay) {
		// TODO Auto-generated method stub
		synchronized (surfaceHolder) {
			switch (raceWay) {
			case 0:
				for (BaseModel model : gameLayout4plant0) {
					if (Math.abs((model.getLocationX() + model.getModelWidth() / 2)
							- (zombie.getLocationX() + zombie.getModelWidth() / 2)) < Math
							.abs((model.getModelWidth() + zombie
									.getModelWidth()) / 2)) {
						if (model instanceof Plant) {
							// ֲ
							model.setAlife(false);
						} else if (model instanceof Bullet) {
							// ӵ
							model.setAlife(false);
							// ʬ
							zombie.setAlife(false);
							model.setAlife(true);
						}
					}
				}
				break;
			case 1:
				for (BaseModel model : gameLayout4plant1) {
					if (Math.abs((model.getLocationX() + model.getModelWidth() / 2)
							- (zombie.getLocationX() + zombie.getModelWidth() / 2)) < Math
							.abs((model.getModelWidth() + zombie
									.getModelWidth()) / 2)) {
						if (model instanceof Plant) {
							// ֲ
							model.setAlife(false);
						} else if (model instanceof Bullet) {
							// ӵ
							model.setAlife(false);
							// ʬ
							zombie.setAlife(false);
							model.setAlife(true);
						}
					}
				}
				break;
			case 2:
				for (BaseModel model : gameLayout4plant2) {
					if (Math.abs((model.getLocationX() + model.getModelWidth() / 2)
							- (zombie.getLocationX() + zombie.getModelWidth() / 2)) < Math
							.abs((model.getModelWidth() + zombie
									.getModelWidth()) / 2)) {
						if (model instanceof Plant) {
							// ֲ
							model.setAlife(false);
						} else if (model instanceof Bullet) {
							// ӵ
							model.setAlife(false);
							// ʬ
							zombie.setAlife(false);
							model.setAlife(true);
						}
					}
				}
				break;
			case 3:
				for (BaseModel model : gameLayout4plant3) {
					if (Math.abs((model.getLocationX() + model.getModelWidth() / 2)
							- (zombie.getLocationX() + zombie.getModelWidth() / 2)) < Math
							.abs((model.getModelWidth() + zombie
									.getModelWidth()) / 2)) {
						if (model instanceof Plant) {
							// ֲ
							model.setAlife(false);
						} else if (model instanceof Bullet) {
							// ӵ
							model.setAlife(false);
							// ʬ
							zombie.setAlife(false);
							model.setAlife(true);
						}
					}
				}
				break;
			case 4:
				for (BaseModel model : gameLayout4plant4) {
					if (Math.abs((model.getLocationX() + model.getModelWidth() / 2)
							- (zombie.getLocationX() + zombie.getModelWidth() / 2)) < Math
							.abs((model.getModelWidth() + zombie
									.getModelWidth()) / 2)) {
						if (model instanceof Plant) {
							// ֲ
							model.setAlife(false);
						} else if (model instanceof Bullet) {
							// ӵ
							model.setAlife(false);
							// ʬ
							zombie.setAlife(false);
							model.setAlife(true);
						}
					}
				}
				break;
			default:
				break;
			}
		}
	}

}
